unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, MSXML_TLB,ComObj,IniFiles;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar1: TToolBar;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    ImageList1: TImageList;
    Tool1: TMenuItem;
    EngineItem: TMenuItem;
    IE_item: TMenuItem;
    Moz_Item: TMenuItem;
    mnuBookMark: TMenuItem;
    mnuEdit: TMenuItem;
    N4: TMenuItem;
    mnuOption: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton6: TToolButton;
    BackCtrl: TToolButton;
    FrwrdCtrl: TToolButton;
    StopCtrl: TToolButton;
    ReLoadCtrl: TToolButton;
    ToolBar3: TToolBar;
    Label1: TLabel;
    txtAddress: TEdit;
    btnMove: TButton;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure txtAddressKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton1Click(Sender: TObject);
    procedure Moz_ItemClick(Sender: TObject);
    procedure IE_ItemClick(Sender: TObject);
    procedure iventMenuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuEditClick(Sender: TObject);
    procedure BackCtrlClick(Sender: TObject);
    procedure FrwrdCtrlClick(Sender: TObject);
    procedure StopCtrlClick(Sender: TObject);
    procedure ReLoadCtrlClick(Sender: TObject);
    procedure mnuOptionClick(Sender: TObject);
    procedure ReadBookMark();
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnMoveClick(Sender: TObject);
    procedure CoolBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BandPositionRead();
    procedure BandPositionWrite();
private
    { Private 錾 }
public
    { Public 錾 }
    MyPath: String;

    procedure CreateMDIChild(const Name: string;
                             const URL : string);
    //j[ǉ
    function AddMenu(OwnerMenu : TMenuItem ; Title : AnsiString ; Index : Integer) : TMenuItem;
    //TufBNg̍쐬
    function  mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TMenuItem):IXMLDOMNode;
end;

const
	BandCount=2;//CoolBar̃oh

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildIE, ChildMoz, About	,Bookmark, Option;

//-------------------֐-----------------
function TMainForm.AddMenu(OwnerMenu : TMenuItem ; Title : AnsiString ; Index : Integer) : TMenuItem;
//ʃj[Captionp̕AƏʃj[ACëʒuɂƂ܂B
var
   NewItem : TMenuItem;
begin
   NewItem := TMenuItem.Create(self);
   NewItem.Caption := Title;
   NewItem.Visible := true;
   NewItem.Enabled := true;
   OwnerMenu.Insert(Index ,NewItem);

   result := NewItem;
end;

//TufBNg쐬
function  TMainForm.mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TMenuItem):IXMLDOMNode;
var
  tmpMenu: TMenuItem;//̃j[
  tmpNode:IXMLDOMNode;
  i:byte;
begin
  //`hJԂ
  for i := 1 to tmpXMLNode.parentNode.childNodes.length-1 do
  begin
    if tmpXMLNode.parentNode.Get_nodeName='directory' then begin
      //TufBNg
      tmpNode:=tmpXMLNode.parentNode.childNodes.item[i].firstChild;
      tmpMenu:=MainForm.AddMenu(xmlMenu,'&'+tmpNode.text , i-1);
      //ACR
			tmpMenu.ImageIndex:=11;
        //fileAURL
          if tmpNode.parentNode.baseName<>'directory' then begin
            tmpMenu.Hint:=tmpNode.parentNode.lastChild.text;
            //ACR
            tmpMenu.ImageIndex:=12;
          end;
        //OnClickCxgo^
          tmpMenu.OnClick:=MainForm.iventMenuClick;

      //fBNg΂xJ
      if tmpNode.parentNode.baseName='directory' then mnuDir(tmpNode,tmpMenu);
    end;
  end;

end;

//-------------------葱---------------
//BookMark̓ǂݍ
procedure TMainForm.ReadBookMark() ;
var
  tmpMenu: tmenuItem;//̃j[
  xmlDoc  :IXMLDOMDOCUMENT;
  DomName :IXMLDOMNode;
  i:byte;
begin

  //XMLIuWFNg̍쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                            IXMLDOMDOCUMENT;
  xmlDoc.load('bookmark.xml');
  xmlDoc.documentElement  ;
  //m[ho^
  for i := 0 to xmlDoc.documentElement.childNodes.length-1 do
  begin
  DomName:=
    xmlDoc.documentElement.childNodes.item[i].firstChild;
  //m[h̃eLXgj[ɒǉ
   tmpMenu:=AddMenu(mnuBookMark,'&'+DomName.Get_text, i+2);
   tmpMenu.ImageIndex:=11;
   //fileAURL
    if DomName.parentNode.baseName<>'directory' then
    begin
      tmpMenu.Hint:=DomName.parentNode.lastChild.text;
      tmpMenu.ImageIndex:=12;
    end;

   //OnClickCxgo^
    tmpMenu.OnClick:=iventMenuClick;

   mnuDir(DomName,tmpMenu);
	end;
end;

//CoolBar̈ʒu̓ǂݍ
procedure TMainForm.BandPositionRead();
var
	ini: TIniFile;
	BandIDNumber,BandWidth: array[0..BandCount-1] of Integer;
	BandBreak: array[0..BandCount-1] of Boolean;
	i: Integer;
begin
	Ini := TIniFile.Create(MyPath+'config.ini');
	with ini do
	try
		for i:=0 to BandCount-1 do
		begin//Band̈ʒuBreakǍ
			BandIDNumber[i]:=
      	ReadInteger('Bar','Band'+IntToStr(i)+'ID',i);
			BandWidth[i]   :=
				ReadInteger('Bar','Band'+IntToStr(i)+'Width',200);
			BandBreak[i]   :=
				ReadBool('Bar','Band'+IntToStr(i)+'Break',true);
		end;
	finally
		Free;
	end;

	CoolBar1.Bands.BeginUpdate;
	for i:=0 to BandCount-1 do
	begin//Band̈ʒuBreak𕜌܂B
		CoolBar1.Bands.FindItemID(BandIDNumber[i]).Index := i;
		CoolBar1.Bands[i].Break := BandBreak[i];
		CoolBar1.Bands[i].Control.Width := BandWidth[i];
	end;
	CoolBar1.Bands.EndUpdate;
end;

//CoolBar̈ʒȕ
procedure TMainForm.BandPositionWrite();
var
	ini: TIniFile;
	i: Integer;
begin
	Ini := TIniFile.Create(MyPath+'config.ini');
  with ini do
	try
		for i:=0 to BandCount-1 do
		begin//Band̈ʒuBreak
			WriteInteger('Bar','Band'+IntToStr(i)
					+'ID',CoolBar1.Bands[i].ID);
			WriteInteger('Bar','Band'+IntToStr(i)
          +'Width',CoolBar1.Bands[i].Control.Width);
			WriteBool('Bar','Band'+IntToStr(i)
          +'Break',CoolBar1.Bands[i].Break);
		end;
	finally
		Free;
	end;

end;


//----------------Cxg----------------

procedure TMainForm.iventMenuClick(Sender: TObject);
var
	WinIni:TIniFile;
  tmpInt:Byte;
Begin
//ubN}[NJ
  //VKEBhEŊJǂ
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	tmpInt:=WinIni.ReadInteger('Option_Window','BookMark',0);
  	WinIni.Free;
  //EBhEȂΐVKɂ
    if self.MDIChildCount=0 then tmpInt:=1;
  //AhXo[URLLq
	  if TMenuItem(Sender).hint<>'' then begin
		  txtAddress.text:=TMenuItem(Sender).hint;
    end;

  if tmpInt=1 then
  begin
	 //VKWindow쐬
   CreateMDIChild('',txtAddress.text);
  end else begin
    //ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Navigate(txtAddress.Text);
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Navigate(txtAddress.Text);
    end;
  end;

End;

procedure TMainForm.CreateMDIChild(const Name: string;const URL : string);
var
  Child1	: Tfrm_IE;
  Child2	: Tfrm_MZ;
var
  WinIni: TIniFile;
  strMoz:string;
  intMoz: Byte;
begin

  //JgfBNgMozillâtH_ɂB
   //MozillâpX擾
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	strMoz:=Winini.ReadString('Option','MozPath','');
    intMoz:=Winini.ReadInteger('Option','Mozilla',0);
    WinIni.Free;
   //Jg̐ݒ
    if intMoz=1 then Chdir(strMoz);

   { MDI qEBhE쐬 }
  //GW̔f
  if IE_Item.Checked=True then begin
    Child1 := Tfrm_IE.Create(Application);
    Child1.Caption := Name;
    Child1.TWeb_IE.Navigate(URL);
  end else begin
    Child2 := Tfrm_MZ.Create(Application);
    Child2.Caption := Name;
    Child2.TWeb_MZ.Navigate(URL);
  end;

end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  //GW̔f
  if IE_Item.Checked=True then begin
    CreateMDIChild('Internet Explorer','');
  end else begin
    CreateMDIChild('Gecko','about:blank');
  end;
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild('',OpenDialog.FileName);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  //Xe[^Xo[̃TCY`
  if ToolBar1.Width>260 then
  begin
    ProgressBar1.Width:=130;
    StatusBar1.Width:=ToolBar1.Width-130;
  end;
  //CoolBar̃TCY`
//    ToolBar2.Width:=self.Width-8;
		btnMove.Left:=ToolBar3.Width-btnMove.Width;
		txtAddress.Width:=ToolBar3.Width-btnMove.Width
 																 -Label1.Width;
end;

procedure TMainForm.txtAddressKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//AhXo[̃AhXŃy[WJ
 if key=13 then begin
	btnMove.OnClick(Sender);
 end;

end;

procedure TMainForm.ToolButton1Click(Sender: TObject);
begin
  //VK쐬
  FileNew1.Execute;
end;

procedure TMainForm.Moz_ItemClick(Sender: TObject);
begin
  Moz_item.Checked:=True;
  IE_Item.Checked:=False;
end;

procedure TMainForm.IE_itemClick(Sender: TObject);
begin
  IE_Item.Checked:=True;
  Moz_Item.Checked:=False;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
	WinIni: TIniFile;
begin
  //NpX擾
  	MyPath:=Application.Exename;
  	MyPath:=ExtractFilePath(MyPath);
  //CoolBar̈ʒuǂݍ
    BandPositionRead();
  //tH[\
  	self.Show;
  //ubN}[Nǂݍ
  	ReadBookMark();
  //NȂMozilla̎gpL̊mF
  	if FileExists(MyPath+'config.ini')= False
    		then  mnuOption.OnClick(Sender);

  //ŌɎgpGW
		WinIni := TIniFile.Create(MyPath+'config.ini');
    if Winini.ReadString('General','LastEngine','IE')='IE' Then
    begin
      IE_Item.Checked:=True;
  		Moz_Item.Checked:=False;
    end else begin
      Moz_item.Checked:=True;
  		IE_Item.Checked:=False;
    end;
  //Mozillagp邩ǂ
  	if Winini.ReadInteger('Option_Main','Mozilla',0)=0 then
    begin
    	Moz_item.Enabled:=False;
    end;
    //IniFilẻ
    WinIni.Free;

end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
	WinIni: TIniFile;
	tmpStr:String;
begin
	if IE_item.Checked=True then begin
  	tmpStr:='IE';
  end else begin
  	tmpStr:='Gecko'
  end;
	//IniFileɌ݂̃GWo^
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	WinIni.WriteString('General','LastEngine',tmpStr);
  	WinIni.Free;
	//CoolBar̈ʒu
    BandPositionWrite();
end;

procedure TMainForm.mnuEditClick(Sender: TObject);
begin
  { ubN}[NGfB^\}

 	frm_BMEdit.Show;
   //URL𑗂
   frm_BMEdit.txtURL.Text:=txtAddress.Text;
	 //O𑗂
	 frm_BMEdit.txtName.Text:=self.ActiveMDIChild.Caption;

end;

//߂
procedure TMainForm.BackCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
   if self.ActiveMDIChild<>nil then begin
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.GoBack;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.GoBack;
    end;
   end;
end;

//i
procedure TMainForm.FrwrdCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.GoForward;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.GoForward;
    end;
end;

//Xgbv
procedure TMainForm.StopCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Stop;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Stop;
    end;
end;

//XV
procedure TMainForm.ReLoadCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
   if self.ActiveMDIChild<>nil then begin
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Refresh;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Refresh;
    end;
   end;
end;    

procedure TMainForm.mnuOptionClick(Sender: TObject);
var
	tmpForm:	Tfrm_Option;
begin
  //IvV\
   tmpForm := Tfrm_Option.Create(Application);
   tmpForm.Visible:=True;
end;

procedure TMainForm.btnMoveClick(Sender: TObject);
var
	WinIni:TIniFile;
  tmpInt:Byte;
Begin
//ړ{^
  //VKEBhEŊJǂ
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	tmpInt:=WinIni.ReadInteger('Option_Window','AddressBar',0);
  	WinIni.Free;
  //EBhEȂΐVKɂ
    if self.MDIChildCount=0 then tmpInt:=1;

  if tmpInt=1 then
  begin
	 //VKWindow쐬
   CreateMDIChild('',txtAddress.text);
  end else begin
    //ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Navigate(txtAddress.Text);
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Navigate(txtAddress.Text);
    end;
  end;

end;


procedure TMainForm.CoolBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//AhX\̃TCYĒ`
	txtAddress.Width:=ToolBar3.Width-btnMove.Width
 																 -Label1.Width;
end;

end.
