unit BookMark;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls,MSXML_TLB, StdCtrls,ComObj, ImgList, ExtCtrls;

type
  Tfrm_BMEdit = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtURL: TEdit;
    btnCancel: TButton;
    btnAdd: TButton;
    btnMD: TButton;
    TreeView1: TTreeView;
    txtName: TEdit;
    btnOK: TButton;
    ImageList1: TImageList;
    btnDel: TButton;
    procedure btnCancelClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnMDClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
  private
    { Private 錾 }
    sltNode : TTreeNode;
    strsURL : TStrings;
  public
    { Public 錾 }
  end;

var
  frm_BMEdit: Tfrm_BMEdit;

implementation

{$R *.DFM}
//֐

//item]bg쐬
function fncNodeItem(tmpNode:TTreeNode;f:Byte):TTreeNode;
var
  i:Byte;
begin
 for i:= 1 to f do
 begin
		tmpNode:=tmpNode.getNextSibling;
 end;

	Result:=tmpNode;

end;

//TufBNg`FbN
function  mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TTreeNode):IXMLDOMNode;
var
  tmpMenu: TTreeNode;//̃j[
  tmpNode:IXMLDOMNode;
  i:byte;
begin
  //`hJԂ
  for i := 1 to tmpXMLNode.parentNode.childNodes.length-1 do
  begin
    if tmpXMLNode.parentNode.Get_nodeName='directory' then begin
      //TufBNg
      tmpNode:=tmpXMLNode.parentNode.childNodes.item[i].firstChild;
      tmpMenu:=frm_BMEdit.TreeView1.Items.AddChild(xmlMenu,tmpNode.text );
      //ACR̕ύX
        tmpMenu.ImageIndex:=0;
        tmpMenu.SelectedIndex:=0;

        //fileAURL
          if tmpNode.parentNode.baseName<>'directory' then begin
            tmpMenu.Data:=PChar(tmpNode.parentNode.lastChild.text);
            frm_BMEdit.strsURL.Add(tmpNode.parentNode.lastChild.text);
            //ACR̕ύX
              tmpMenu.ImageIndex:=1;
              tmpMenu.SelectedIndex:=1;
          end else begin
            //URL̊i[
              frm_BMEdit.strsURL.Add('tH_');
          end;
      //fBNg΂xJ
      if tmpNode.parentNode.baseName='directory' then mnuDir(tmpNode,tmpMenu);
    end;
  end;
end;

//`h𐔂
function fncCountChild(Node:TTreeNode):integer;
var
  tmpNode:TTreeNode;
  f:Byte;
begin
  //f̏
    f:=0;
  //`
    while tmpNode <> nil do
    begin
      tmpNode:= tmpNode.getNextSibling;
      f:=f+1;
    end;
  //߂l
    Result:=f;
end;


//葱

procedure subAddFile(tmpNode:IXMLDOMNode; f:Byte;
                     tmpName:string;tmpURL:string);
var
  XMLDoc : IXMLDOMDOCUMENT;
  xmlNode   : IXMLDOMNode;
  paragraph : IXMLDOMNode;
  pph : String;
  i : Byte;
begin
  //XMLDocument쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                        IXMLDOMDOCUMENT;

  //sCfgi/rootj
    for i:=1 to f do begin pph:=pph+'  'end;
    paragraph:=XMLDOC.createTextNode(#10+pph);
    tmpNode.appendChild(paragraph);
    pph:='';
  //<file>쐬
    xmlNode:=xmldoc.createElement('file');
    tmpNode.appendChild(xmlNode);
    //sCfgi/filej
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';

  //<name>쐬
    xmlNode:=xmldoc.createElement('name');
    xmlNode.text:=tmpName;
    tmpNode.lastChild.appendChild(xmlNode);
    //sCfgi/namej
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';

  //<url>쐬
    XMLNode:=XMLDoc.createElement('url');
    XMLNode.text:=tmpURL;
    tmpNode.lastchild.appendChild(XMLNode);
    //sCfgi/urlj
      for i:=1 to f do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';
end;

//fBNg̍쐬
procedure subAddDir(tmpNode:IXMLDOMNode; f:Byte;
                     tmpName:string);
var
  XMLDoc : IXMLDOMDOCUMENT;
  xmlNode   : IXMLDOMNode;
  paragraph : IXMLDOMNode;
  pph : String;
  i : Byte;
begin
  //XMLDocument쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                        IXMLDOMDOCUMENT;

  //sCfgi/rootj
    if f=1 then
    begin
    for i:=1 to f do begin pph:=pph+'  'end;
    end else begin
    for i:=1 to f-1 do begin pph:=pph+'  'end;
    end;
     //TufBNgȂXy[XȂB
      paragraph:=XMLDOC.createTextNode(#10+pph);

    tmpNode.appendChild(paragraph);
    pph:='';
  //<directory>쐬
    xmlNode:=XMLdoc.createElement('directory');
    tmpNode.appendChild(xmlNode);
    //sCfgi/directoryj
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';
  //<name>쐬
    xmlNode:=XMLdoc.createElement('name');
    xmlNOde.text:=tmpName;
    tmpNode.lastChild.appendChild(xmlNode);

end;

//XMLt@C̐
procedure subMKXML(tmpNode:TTreeNode;tmpXML:IXMLDOMNode);
var
  i:Byte;
begin
   for i:=0 to fncCountChild(tmpNode)-1 do
   begin
    //tH_t@C`FbN
    if tmpNode.Count=0 then
    begin
      subAddFile(tmpXML,tmpNode.Level+2 ,
        tmpNode.Text,frm_BMEdit.strsURL.Strings[tmpNode.AbsoluteIndex]);

    end else begin
      subAddDir(tmpXML,tmpNode.Level+2,
        tmpNode.Text);
      //TufBNgǉ
      subMKXML(tmpNode.Item[0],tmpXML.lastChild)
    end;
    //̃m[h֍s
    tmpNode:= tmpNode.getNextSibling;
   end;
end;


//----------------Cxg----------------
procedure Tfrm_BMEdit.FormCreate(Sender: TObject);
var
  tmpNode: TTreeNode;
  xmlDoc  :IXMLDOMDOCUMENT;
  DomName :IXMLDOMNode;
  xmlNode :IXMLDOMNode;
  i:byte;
begin
  //strsURL̐
  strsURL:=TStringList.Create;

  //XMLIuWFNg̍쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  xmlDoc.load('bookmark.xml');
  xmlDoc.documentElement  ;
  //m[ho^
  for i := 0 to xmlDoc.documentElement.childNodes.length-1 do
  begin
  DomName:=
    xmlDoc.documentElement.childNodes.item[i].firstChild;
  //m[h̃eLXgj[ɒǉ
   tmpNode:=TreeView1.Items.Add(nil,DomName.text);
  //ACR̕ύX
   tmpNode.ImageIndex:=0;
   tmpNode.SelectedIndex:=0;

  //fileAURLi[
    if DOMName.parentNode.baseName<>'directory' then begin
      xmlNode:=DOMName.Get_nextSibling;
      if i>0 then
      begin
      fncNodeItem
        (TreeView1.TopItem,i).Data:=PChar(xmlNode.text);
      //URLi[
      strsURL.Add(xmlNode.text);
      end;
     //ACR̕ύX
       tmpNode.ImageIndex:=1;
       tmpNode.SelectedIndex:=1;
    end else begin
      //URLi[
      strsURL.Add('tH_');
		end;

  //Tuj[ǉ
  mnuDir(DomName,tmpNode);
  end;
end;

procedure Tfrm_BMEdit.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
	sltNode:=Node;
{  //fobNp
  txtURL.text:=strsUrl.Strings[Node.AbsoluteIndex];
  txtName.Text:=node.text;}
end;

//URL̒ǉ
procedure Tfrm_BMEdit.btnAddClick(Sender: TObject);
var
  tmpNode:TTreeNode;//쐬m[h
  tmpNode2:TTreeNode;//ړm[h
  tmpNode3:TTreeNode;//`h
  f:Byte;
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;

  //tH_Ȃqɂ
  if sltNode.ImageIndex=0 then
  begin
    //tH_ɎqȂꍇ
    if sltNode.Count=0 then begin
    	tmpNode3:=TreeView1.Items.AddChildFirst(TreeView1.Selected,'123');
    end else begin
    	tmpNode3:=tmpNode2;
    end;
  	tmpNode2:=sltNode.getFirstChild;
  end else begin
    //oOp
    	tmpNode3:=tmpNode2;
      tmpNode2:=sltNode;
  end;

  //t@C̍쐬
    tmpNode:=TreeView1.Items.Add(TreeView1.Selected,txtName.Text);
  //ACR̕ύX
    tmpNode.ImageIndex:=1;
    tmpNode.SelectedIndex:=1;

  //URLf[^̍쐬
    f:=strsURL.add(txtURL.Text);
    //URLf[^̈ړ
      strsURL.Move(f,tmpNode2.AbsoluteIndex);
  //t@C̈ړ
    tmpNode.MoveTo(tmpNode2,naInsert);

  //`h̍폜
    tmpNode3.Delete;

end;

//m[h̍폜
procedure Tfrm_BMEdit.btnDelClick(Sender: TObject);
begin
  //NodȇI𔻒f
  if sltNode<>nil then begin
  	//폜
  		sltNode.Delete;
      strsURL.Delete(sltNode.AbsoluteIndex);
  end;
end;

//tH_̍쐬
procedure Tfrm_BMEdit.btnMDClick(Sender: TObject);
var
  tmpNode:TTreeNode;//쐬m[h
  tmpNode2:TTreeNode;//ړm[h
  tmpNode3:TTreeNode;//`h
  f:Byte;
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;

  //tH_Ȃqɂ
  if sltNode.ImageIndex=0 then
  begin
    //tH_ɎqȂꍇ
    if sltNode.Count=0 then begin
    	tmpNode3:=TreeView1.Items.AddChildFirst(TreeView1.Selected,'123');
    end else begin
    	tmpNode3:=tmpNode2;
    end;
  	tmpNode2:=sltNode.getFirstChild;
  end else begin
    //oOp
    	tmpNode3:=tmpNode2;
      tmpNode2:=sltNode;
  end;

  //t@C̍쐬
    tmpNode:=TreeView1.Items.Add(TreeView1.Selected,'VtH_');
  //ACR̕ύX
    tmpNode.ImageIndex:=0;
    tmpNode.SelectedIndex:=0;

  //URLf[^̍쐬
    f:=strsURL.add(txtURL.Text);
    //URLf[^̈ړ
      strsURL.Move(f,tmpNode2.AbsoluteIndex);
  //t@C̈ړ
    tmpNode.MoveTo(tmpNode2,naInsert);

  //`h̍폜
    tmpNode3.Delete;

  //tH_ύX
  	tmpNode.EditText;
end;

//ubN}[NXVďI
procedure Tfrm_BMEdit.btnOKClick(Sender: TObject);
var
  XMLDoc : IXMLDOMDOCUMENT;
  paragraph : IXMLDOMNode;
  procinst  : IXMLDOMProcessingInstruction;
  tmpNode : TTreeNode;
  i:byte;
begin
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  //XML錾
    procinst := XMLdoc.createProcessingInstruction( 'xml',
           'version="1.0" encoding="Shift_JIS"' );
    XMLdoc.appendChild( procinst );
  //[g쐬
   XMLDoc.documentElement:=XMLdoc.createElement('bookmark');

  //tmpNodȅ
    tmpNode:=TreeView1.TopItem;
  //qNodeǉ     
   for i:=0 to fncCountChild(tmpNode)-1 do
   begin
    //tH_t@C`FbN
    if tmpNode.Count=0 then
    begin
      subAddFile(XMLDoc.documentElement,1,
        tmpNode.Text,strsURL.Strings[tmpNode.AbsoluteIndex]);

    end else begin
      subAddDir(XMLDoc.documentElement,1,
        tmpNode.Text);
      //TufBNgǉ
      subMKXML(tmpNode.Item[0],XMLDoc.documentElement.lastChild)
    end;
    //̃m[h֍s
    tmpNode:= tmpNode.getNextSibling;
   end;

 	//sCfgi/bookmarkj
    paragraph:=XMLDOC.createTextNode(#10);
    XMLDoc.documentElement.appendChild(paragraph);

  //t@Co
  XMLDoc.save('BookMark.xml');
	self.Close;
end;

//ubN}[NXVɏI
procedure Tfrm_BMEdit.btnCancelClick(Sender: TObject);
begin
	self.Close;
end;

end.

