unit childIE;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, ComCtrls,
  ToolWin, ImgList, OleCtrls, SHDocVw,main;

type
  Tfrm_IE = class(TForm)
    TWeb_IE: TWebBrowser;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure TWeb_IEProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure TWeb_IEStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TWeb_IETitleChange(Sender: TObject; const Text: WideString);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TWeb_IECommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
  private
    { Private 錾 }
    strURL: string;
    blBack	: WordBool;
    blFrwrd	: WordBool;
    blStop 	: WordBool;
    blReLoad: WordBool;
  public
    { Public 錾 }
  end;

implementation


{$R *.DFM}

procedure Tfrm_IE.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //lɖ߂
  MainForm.ProgressBar1.Position:=0;
  MainForm.txtAddress.Text:='';
  MainForm.StatusBar1.Panels.Items[0].Text:='';
  MainForm.ReLoadCtrl.Enabled:=False;
  //
  Action := caFree;

end;

procedure Tfrm_IE.TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch; var Cancel: WordBool);
begin
  //炵tH[쐬
  MainForm.CreateMDIChild('Internet Explorer',strURL);
  //irQ[g̃LZ
  Cancel := True;
end;

procedure Tfrm_IE.TWeb_IEProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
//vOXo[̕\
begin
 //ǂݍ݋\
 self.tag:=Progress;
 if ProgressMax<>0 then begin
    MainForm.Progressbar1.Position:= Progress*100
                 div ProgressMax;
 end else begin

    //Sēǂݍ񂾂珉
    if Progress=ProgressMax then begin
      MainForm.Progressbar1.Position:=0;
    end;
 end;

end;

procedure Tfrm_IE.TWeb_IEStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  //}EXǂĂ邩`FbN
  MainForm.StatusBar1.Panels.Items[0].Text:=text;
  strURL:=text;
end;

procedure Tfrm_IE.TWeb_IETitleChange(Sender: TObject;
  const Text: WideString);
begin
  //^Cgς̏
  self.Caption:=text;
  MainForm.txtAddress.Text:=TWeb_ie.LocationURL;
end;

procedure Tfrm_IE.FormResize(Sender: TObject);
begin
  //TCY̒`
  TWeb_ie.Width:=Self.Width-8;
  TWeb_ie.Height:=Self.Height-28;
end;

procedure Tfrm_IE.FormCreate(Sender: TObject);
begin
  self.OnResize(Sender);

  //߂Eiނ̏󋵂L
 	With Main.MainForm do begin
  	blBack:=BackCtrl.Enabled;
  	blFrwrd:=FrwrdCtrl.Enabled;
  	blStop:=StopCtrl.Enabled;
  end;
end;

procedure Tfrm_IE.FormActivate(Sender: TObject);
begin
  With Main.MainForm do begin
  	//ANeBȕ
  		//URL̕ύX
  		txtAddress.Text:=TWeb_ie.LocationURL;
  	//vOXo[̕ύX
  		ProgressBar1.Position:=self.Tag;

  //߂Eiނ̏󋵂ύX
 	 	BackCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blBack;
  	FrwrdCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blFrwrd;
  	StopCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blStop;
    ReLoadCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blReLoad;
  end;
end;

procedure Tfrm_IE.TWeb_IECommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  With Main.MainForm do begin
  	case Command of
  	  CSC_NAVIGATEBACK: BackCtrl.Enabled := Enable;
  	  CSC_NAVIGATEFORWARD: FrwrdCtrl.Enabled := Enable;
   	end;
    ReLoadCtrl.Enabled:=True;
  //߂Eiނ̏󋵂L
  	Tfrm_IE(ActiveMDIChild).blBack:=BackCtrl.Enabled;
  	Tfrm_IE(ActiveMDIChild).blFrwrd:=FrwrdCtrl.Enabled;
  	Tfrm_IE(ActiveMDIChild).blStop:=StopCtrl.Enabled;
    Tfrm_IE(ActiveMDIChild).blReLoad:=ReLoadCtrl.Enabled;
  end;
end;

end.
